'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._autobind = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                  * @autobind decorator
                                                                                                                                                                                                                                                                  *
                                                                                                                                                                                                                                                                  * @author  Avraam Mavridis      <avr.mav@gmail.com>
                                                                                                                                                                                                                                                                  *
                                                                                                                                                                                                                                                                  */


var _helpers = require('./helpers');

/**
 * Autobind function decorator
 *
 * @method _autobind
 * @param { function }
 *
 * @return { function }  decorator function
 */
var _autobind = exports._autobind = function _autobind() {
  return function (target, key, descriptor) {
    var func = descriptor.value;
    (0, _helpers.descriptorIsFunc)(key, func);
    delete descriptor.writable;
    delete descriptor.value;

    return _extends({}, descriptor, {
      get: function get() {
        if (this === target.prototype || this.hasOwnProperty(key)) {
          return func;
        }

        Object.defineProperty(this, key, {
          value: func,
          configurable: true,
          writable: true
        });
        return func;
      }
    });
  };
};