'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._deprecated = undefined;

var _helpers = require('./helpers');

var _validationHelpers = require('./validationHelpers');

/**
 * Deprecated decorator
 *
 * @method _deprecated
 *
 *
 * @return { function }  decorator function
 */
/**
* Deprecated decorator
*
* @author  Avraam Mavridis      <avr.mav@gmail.com>
*
*/
var _deprecated = exports._deprecated = function _deprecated(msg) {
  if (!(0, _validationHelpers._isString)(msg)) {
    throw Error('Warning message should be a string.');
  }
  return function (target, key, descriptor) {
    var func = descriptor.value;
    (0, _helpers.descriptorIsFunc)(target, func);
    var name = target.constructor.name;
    descriptor.value = function () {
      console.warn(name + '#' + key + ' : ' + msg);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return func.apply(this, args);
    };
    return descriptor;
  };
};