'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._memoization = undefined;

var _helpers = require('./helpers');

var _memoization = exports._memoization = function _memoization() {
  var cache = new Map();

  return function (key, target, descriptor) {
    var func = descriptor.value;
    (0, _helpers.descriptorIsFunc)(key, func);
    descriptor.value = function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var ckey = args.join('');
      if (cache.has(ckey)) {
        return cache.get(ckey);
      }
      var res = func.apply(this, args);
      cache.set(ckey, res);
      return res;
    };
    return descriptor;
  };
}; /**
   * Memoization decorators
   *
   * @author  Avraam Mavridis      <avr.mav@gmail.com>
   *
   */