"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
* Validates that the number of values passed to a function
* is equal to the number of arguments that the function accepts.
*
* @author  Avraam Mavridis      <avr.mav@gmail.com>
*
*/
var _passedValuesEqualToNumberOfArguments = exports._passedValuesEqualToNumberOfArguments = function _passedValuesEqualToNumberOfArguments() {
  var failSilent = arguments.length <= 0 || arguments[0] === undefined ? false : arguments[0];

  return function (target, key, descriptor) {
    var func = descriptor.value;
    descriptor.value = function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (func.length !== args.length) {
        if (failSilent) return;
        throw Error("Only " + func.length + " values should be passed to the function");
      }
      return func.apply(this, args);
    };
    return descriptor;
  };
};