"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (restLength) {
  return function (key, target, descriptor) {
    var func = descriptor.value;
    descriptor.value = function () {
      for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
        rest[_key] = arguments[_key];
      }

      if (rest.length - func.length !== restLength) {
        throw Error("Number of rest values is not equal to " + restLength);
      }
      func.call(this, rest);
    };
    return descriptor;
  };
};